#define MAX_FILE_NAME_LENGTH 50
#define MAX_EVENT_NAME 24
#define INFTY 10000000
#define NEGINFTY -10000000
#define NONE 0
#define UP 1
#define DOWN 2
#define LEFT 3
#define RIGHT 4
#define SKEW 5

typedef char boolean;

#ifndef true
#define true 1
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef false
#define false 0
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef EXIT_FAILURE
#define EXIT_FAILURE (-1)
#endif

#define ReadOpenParenthesis 0
#define ReadSubTree 1
#define ReadLabel 2
#define ReadWeight 3
#define ReadSize 4
#define ReadEntries 5
#define Done 6

#define MAXSIZE 70000

int numSpecies;
int edgeCount;

boolean verbose;
boolean whitespace(char c);

#define OLS 1
#define BAL 2
#define BALSPR 3
#define NJ 7

#define USER 0

/*constant for minimum improvement...to avoid looping problem caused
  by round-off error*/
#define EPSILON .0000001
#define LARGE 3.0
