#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fastme.h"
#include "graph.h"

void printMatrix(double **D, int size, set *nodes, FILE *ofile)
{
  node *v,*w;
  set *S,*T;
  fprintf(ofile,"%d\n",size);
  for(S=nodes;NULL!=S;S=S->secondNode)
    {
      v=S->firstNode;
      fprintf(ofile,"%-9.9s",v->label);
        for(T=nodes;NULL!=T;T=T->secondNode)
	  {
	    w=T->firstNode;
	    fprintf(ofile,"%8.5lf",D[v->index2][w->index2]);
	  }
	fprintf(ofile,"\n");
    }
}
	    
